<template>
<div v-if="this.$store.getters.authenticatedUser">
    <b-container>
      <b-modal ref="my-modal" hide-footer title="Confirmation message">
      <div class="d-block text-center">
        <h6>Operator has been added!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">
          <router-link :to="{name: 'Operators'}">
          <b-button class="mt-3" variant="success" block >Ok</b-button>
          </router-link>
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
    <b-modal ref="failure-modal" hide-footer title="Rejection message">
      <div class="d-block text-center">
        <h6>The operator you want to create already exists!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">          
          <b-button class="mt-3" variant="warning" block @click="hideModal" >Ok</b-button>          
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>

<br>
<br> <b-row>
<b-col cols="3"></b-col>
<b-col cols="6">
  <b-card id="addCard" bg-variant="light">
       <b-row rows="2"  > <p style=" color: #22b574 ; font-size: 200%">
            Create New Operator
            </p>
        </b-row>
        <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Username:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "username"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyUsernameAlert" variant="warning">
                  You have to provide the Username of the operator!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Name:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "name"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyNameAlert" variant="warning">
                  You have to provide the name of the operator!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Email:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "email"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyEmailAlert" variant="warning">
                  You have to provide the e-mail of the operator!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Phone:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "phone"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyPhoneAlert" variant="warning">
                  You have to provide the phone of the operator!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
<b-row>
<b-col>
</b-col>
<b-col>
<div  id="SaveButtonRow" @click="checkForm"  @mouseover="SavemouseOver"  @mouseleave="SavemouseOut">
 <img v-if="HoverSave"
 width="25%" src= "../assets/SaveButtonAtHover.png" >
  <img v-if="OutOfSave"
 width="25%" src= "../assets/SaveButton.png" >
 </div>
</b-col>
</b-row>
  </b-card>
   </b-col>
<b-col cols="3"></b-col>
</b-row>
    </b-container>
</div>
<div v-else>
  <NoAccess></NoAccess>
  </div>
</template>
<script>
import NoAccess from '../components/NoAccess.vue'
import {mapGetters} from 'vuex'

export default {
  computed: {
    ...mapGetters([
      'authenticatedUser'
    ])
  },
  data () {
    return {
      emptyUsernameAlert: false,
      emptyNameAlert: false,
      emptyPhoneAlert: false,
      emptyEmailAlert: false,
      username: '',
      name: '',
      email: '',
      phone: '',
      HoverSave: false,
      OutOfSave: true
    }
  },
  components: {NoAccess},
  beforeCreate () {
    console.log(this.$store.getters.authenticatedUser)
    if (this.$store.getters.authenticatedUser === false) {
      this.$router.push({name: 'home'})
    }
  },
  created () {
  },
  methods: {
    

    checkForm () {
      // check if all required fields are filled
        if (!this.username) {
          this.emptyUsernameAlert = true
        }
        else if (!this.name) {
          this.emptyNameAlert = true
        }
        else if (!this.email) {
          this.emptyEmailAlert = true
        }
        else if (!this.phone) {
          this.emptyPhoneAlert = true
        }
       else {
        this.CreateOperator()
       }
    },
    CreateOperator () {
      let DataToBeSent = []
      DataToBeSent = {
        username: this.username,
        name: this.name,
        email: this.email,
        phone: this.phone
      }
      this.$store.dispatch('createOperator', DataToBeSent).then(
        response => {

          console.log(response)
          if(response.status) {
            if (response.status = '201'){ this.$refs['my-modal'].show()}
            } 
          else if (response.response.status = '409')
         {this.$refs['failure-modal'].show()}

        }
      )
    },
    hideModal () {
      this.$refs['failure-modal'].hide()
    },
    SavemouseOver () {
      this.HoverSave = true
      this.OutOfSave = false
    },
    SavemouseOut () {
      this.HoverSave = false
      this.OutOfSave = true
    }}
}
</script>

<style scoped>

#addCard {
  border : 0px
}
#SaveButtonRow {
  text-align : right;
   cursor: pointer;
}
</style>
